#include "volset.h"
#include "volset-helper.h"

ONE_BYTE_INT CheckSum(ONE_BYTE_INT *memory, int length)
{
   int i;
   ONE_BYTE_INT checksum = 0;
   
   for(i=0; i<length; checksum = checksum ^ memory[i] ,i++);
   
   return checksum;
}

void DFlushVolume(void) {};

/*
 * int osi_audit())
 * 
 * Parameters: 
 * 
 * Function: Copied _verbatim_ out of vos.c.
 *           Makes compiles go happy.
 * 
 * 06/06/01 14:18:02
 * 
 */
int osi_audit()
{
/* this sucks but it works for now.
*/
return 0;
}

afs_int32 ParseHost(char *aname, struct sockaddr_in *asockaddr)
{ /*ParseHost*/
   
   struct hostent *host;              /*Host entry*/
   afs_int32 addr;		    /*Converted address*/
   afs_int32 b1, b2, b3, b4;	    /*Byte-sized address chunks*/
   afs_int32 code;	            /*Return code from sscanf()*/
   afs_int32 tmp1,tmp2;
   
   /*
    * Try to parse the given name as a dot-notation IP address first.
    */
   code = sscanf(aname, "%d.%d.%d.%d", &b1, &b2, &b3, &b4);
   if (code == 4) {
      /*
       * Four chunks were read, so we assume success.  Construct the socket.
       */
      asockaddr->sin_family = AF_INET;
      asockaddr->sin_port   = 0;
      addr = (b1<<24) | (b2<<16) | (b3<<8) | b4;
      bcopy(&addr,&tmp1,sizeof(afs_int32));
      tmp2 = htonl(tmp1);
      bcopy(&tmp2, &asockaddr->sin_addr.s_addr, sizeof(afs_int32));
      return(0);
   }
   
   /*
    * The given string isn't a dotted IP address.  Try to map it as a host
    * name, or leave it as a wild-card.
    */
   
   if (strcmp(aname, ".*") == 0) {
      bzero(asockaddr, sizeof(struct sockaddr_in));
      return 0;
   }
   
   host = (struct hostent *)gethostbyname(aname);
   if (!host) {
      
      /*
       * No such luck, return failure.
       */
      printf("Error: Could not lookup host!\n");
      return(-1);
   }
   /*
    * We found a mapping; construct the socket.
    */
   asockaddr->sin_family = AF_INET;
   asockaddr->sin_port   = 0;
   bcopy(host->h_addr, (afs_int32 *)&tmp1, sizeof(afs_int32));
   tmp2 = htonl(tmp1);
   bcopy(&tmp2,&(asockaddr->sin_addr.s_addr),
	 sizeof(asockaddr->sin_addr.s_addr));
   return(0);
} /*ParseHost*/

afs_int32 SafeATOI(char *anum)
{
   afs_int32 total=0;
   
   for (; *anum; anum++) {
      if ((*anum < '0') || (*anum > '9')) return -1;
      total = (10 * total) + (afs_int32)(*anum - '0');
   }
   return total;
}

/* get partition id from a name */
afs_int32 GetPartitionID(afs_int32 *aval, char *aname)
{
   /*GetPartitionID */
   
   register char tc;
   char ascii[3];
   
   /* special-case "anything" */
   if (strcmp(aname, ".*") == 0) {
      *aval = -1;
      return 0;
   }
   tc = *aname;
   if (tc == 0) return -1;	/* unknown */
   /* numbers go straight through */
   if (tc >= '0' && tc <= '9') {
      *aval = SafeATOI(aname);
      return 0;
   }
   /* otherwise check for vicepa or /vicepa, or just plain "a" */
   ascii[2] = 0;
   if (strlen(aname) <= 2) {
      strcpy(ascii, aname);
   }
   else if (!strncmp(aname, "/vicep", 6)) {
      strncpy(ascii, aname+6, 2);
   }
   else if (!strncmp(aname, "vicep", 5)) {
      strncpy(ascii, aname+5, 2);
   }
   else return(-1);	/* bad partition name */
   /* now partitions are named /vicepa ... /vicepz, /vicepaa, /vicepab, .../vicepzz, and are numbered
      from 0.  Do the appropriate conversion */
   if (ascii[1] == 0) {
      /* one char name, 0..25 */
      if (ascii[0] < 'a' || ascii[0] > 'z') return -1;  /* wrongo */
      *aval = ascii[0] - 'a';
      return 0;
   }
   else {
      /* two char name, 26 .. <whatever> */
      if (ascii[0] < 'a' || ascii[0] > 'z') return -1;  /* wrongo */
      if (ascii[1] < 'a' || ascii[1] > 'z') return -1;  /* just as bad */
      *aval = (ascii[0] - 'a') * 26 + (ascii[1] - 'a') + 26;
      return 0;
   }
} /*GetPartitionID*/
